Wins Security Information

보안 정보

앞 내용 보기 다음 내용 보기
취약점 정보[CVE-2021-43778] GLPI Barcode Directory Traversal
작성일 2021-12-31 조회 1668

 

 

GLPI의 Barcode 플러그인에 Directory Traversal 취약점이 존재합니다.

 

해당 취약점은 /glpi/plugins/barcode/front/send.php 경로에서 file 파라미터에 대한 부적절한 유효성 검사로로 인해 발생합니다. 원격의 공격자는 악의적으로 조작된 요청을 전송하여 공격할 수 있습니다.

 

공격 성공 시, 임의의 정보가 유출될 수 있습니다. 

 

 

 

취약점 설명

 

NVD - CVE-2021-43778

CVSS v2.0 Severity and Metrics:

Base Score: 5.0 MEDIUM

 

 

[그림1. NVD 내역]

 

 

 

취약점 분석

 

해당 취약점은 /glpi/plugins/barcode/front/send.php 경로에서 file 파라미터에 대한 부적절한 유효성 검사로로 인해 발생합니다. 

 

 

 

[그림2. /front/send.php 코드 일부(1)]

 

 

/front/send.php 코드의 일부를 확인한 결과 ../ 또는 .. 문자열과 같이 경로 우회 취약점에 흔히 사용되는 공격 문자열에 대해 확인을 진행하지만 해당 문자열을 포함한 경로에 대해서는 별도의 검증없이 처리하는 것을 확인할 수 있습니다. 공격 문자열이 존재하는지만 확인할 뿐, 공격 문자열을 제거하거나 접근을 막는 조치가 취해지지 않아 취약합니다.

 

 

 

[그림3. /front/send.php 코드 일부(2)]

 

 

패치된 버전은 공격문자열이 있는지 확인한 후 해당 경로를 filename 파라미터를 기준으로 분리하여 실재로 존재하는 파일에 대한 경로인지 검사하는 코드를 거칠 수 있도록 코드가 수정되었습니다.

 

 

 

공격 분석 및 테스트

 

CVE-2021-43778의 공격 패킷은 다음과 같습니다.

 

 

 

[그림 4. 공격 패킷]

 

 

 

취약점 대응 방안

 

1. 최신 버전 사용

 

해당 벤더사에서 발표한 최신 버전으로 업데이트한다.

https://github.com/pluginsGLPI/barcode/releases

 

2. WINS Sniper 제품군 대응 방안

 

[5863] GLPI Plugin Barcode send.php file Directory Traversal

 

첨부파일 첨부파일이 없습니다.
태그 CVE-2021-43778  GLPI